Index: cpukit/libcsupport/include/rtems/libio.h
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libcsupport/include/rtems/libio.h,v
retrieving revision 1.55
diff -p -u -u -r1.55 libio.h
--- cpukit/libcsupport/include/rtems/libio.h	9 Mar 2009 14:11:22 -0000	1.55
+++ cpukit/libcsupport/include/rtems/libio.h	23 Apr 2009 07:54:39 -0000
@@ -40,6 +40,11 @@ extern "C" {
 #endif
 
 /*
+ * A 64bit file offset for internal use by RTEMS. Based on the newlib type.
+ */
+typedef _off64_t rtems_off64_t;
+
+/*
  * Valid RTEMS file types.
  */
 
@@ -83,9 +88,9 @@ typedef int (*rtems_filesystem_ioctl_t)(
   void          *buffer
 );
 
-typedef off_t (*rtems_filesystem_lseek_t)(
+typedef rtems_off64_t (*rtems_filesystem_lseek_t)(
   rtems_libio_t *iop,
-  off_t          length,
+  rtems_off64_t  length,
   int            whence
 );
 
@@ -101,7 +106,7 @@ typedef int (*rtems_filesystem_fchmod_t)
 
 typedef int (*rtems_filesystem_ftruncate_t)(
   rtems_libio_t *iop,
-  off_t          length
+  rtems_off64_t  length
 );
 
 typedef int (*rtems_filesystem_fpathconf_t)(
@@ -347,8 +352,8 @@ typedef enum
 
 struct rtems_libio_tt {
     rtems_driver_name_t                    *driver;
-    off_t                                   size;      /* size of file */
-    off_t                                   offset;    /* current offset into file */
+    rtems_off64_t                           size;      /* size of file */
+    rtems_off64_t                           offset;    /* current offset into file */
     uint32_t                                flags;
     rtems_filesystem_location_info_t        pathinfo;
     rtems_id                                sem;
@@ -366,7 +371,7 @@ struct rtems_libio_tt {
 
 typedef struct {
     rtems_libio_t          *iop;
-    off_t                   offset;
+    rtems_off64_t           offset;
     char                   *buffer;
     uint32_t                count;
     uint32_t                flags;
@@ -441,10 +446,10 @@ typedef int (*rtems_libio_ioctl_t)(
   void       *buffer
 );
 
-typedef int (*rtems_libio_lseek_t)(
-  int    fd,
-  off_t  offset,
-  int    whence
+typedef rtems_off64_t (*rtems_libio_lseek_t)(
+  int           fd,
+  rtems_off64_t offset,
+  int           whence
 );
 
 /*
Index: cpukit/libfs/src/dosfs/dosfs.h
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libfs/src/dosfs/dosfs.h,v
retrieving revision 1.6
diff -p -u -u -r1.6 dosfs.h
--- cpukit/libfs/src/dosfs/dosfs.h	4 Sep 2008 08:33:05 -0000	1.6
+++ cpukit/libfs/src/dosfs/dosfs.h	23 Apr 2009 07:54:40 -0000
@@ -32,6 +32,11 @@ extern rtems_filesystem_operations_table
 #define MSDOS_FMT_FAT16  2
 #define MSDOS_FMT_FAT32  3
 
+#define MSDOS_FMT_INFO_LEVEL_NONE   (0)
+#define MSDOS_FMT_INFO_LEVEL_INFO   (1)
+#define MSDOS_FMT_INFO_LEVEL_DETAIL (2)
+#define MSDOS_FMT_INFO_LEVEL_DEBUG  (3)
+
 /*
  * data to be filled out for formatter: parameters for format call
  * any parameter set to 0 or NULL will be automatically detected/computed
@@ -51,6 +56,7 @@ typedef struct {
                                   /*   value. This can optimize clusters   */
                                   /*   to be located at start of track     */
                                   /*   or start of flash block             */
+  int       info_level;           /* The amount of info to output          */
 } msdos_format_request_param_t;
 
 /*=========================================================================*\
Index: cpukit/libfs/src/dosfs/fat.h
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libfs/src/dosfs/fat.h,v
retrieving revision 1.15
diff -p -u -u -r1.15 fat.h
--- cpukit/libfs/src/dosfs/fat.h	29 Jan 2009 16:12:44 -0000	1.15
+++ cpukit/libfs/src/dosfs/fat.h	23 Apr 2009 07:54:40 -0000
@@ -250,7 +250,7 @@ extern "C" {
 
 #define FAT_GET_FSINFO_TRAIL_SIGNATURE(x)     FAT_GET_VAL32(x,508)
 #define FAT_SET_FSINFO_TRAIL_SIGNATURE(x,val) FAT_SET_VAL32(x,508,val)
-#define FAT_FSINFO_TRAIL_SIGNATURE_VALUE  (0x000055AA)
+#define FAT_FSINFO_TRAIL_SIGNATURE_VALUE  (0xAA550000)
 /* 
  * I read FSInfo sector from offset 484 to access the information, so offsets 
  * of these fields a relative
@@ -351,15 +351,31 @@ typedef struct fat_fs_info_s
 } fat_fs_info_t;
 
 /*
- * if the name we looking for is file we store not only first data cluster
- * number, but and cluster number and offset for directory entry for this
- * name
+ * FAT position is a the cluster and the offset into the
+ * cluster.
  */
-typedef struct fat_auxiliary_s
+typedef struct fat_pos_s
 {
     uint32_t   cln;
     uint32_t   ofs;
-} fat_auxiliary_t;
+} fat_pos_t;
+
+/*
+ * If the name we looking for is file we store not only first data cluster
+ * number, but and cluster number and offset for directory entry for this
+ * name. We also add the LFN start offset so we can delete it the whole
+ * file name. We can then use this to delete the file.
+ */
+typedef struct fat_dir_pos_s
+{
+    fat_pos_t  sname;
+    fat_pos_t  lname;
+} fat_dir_pos_t;
+
+/*
+ * Set the long name entries to this value for a short file name.
+ */
+#define FAT_FILE_SHORT_NAME (0xffffffff)
 
 #define FAT_FAT_OFFSET(fat_type, cln)                  \
     ((fat_type) & FAT_FAT12 ? ((cln) + ((cln) >> 1)) : \
@@ -380,6 +396,17 @@ typedef struct fat_auxiliary_s
 #define FAT_OP_TYPE_READ  0x1
 #define FAT_OP_TYPE_GET   0x2
 
+static inline void
+fat_dir_pos_init(
+    fat_dir_pos_t *dir_pos
+    )
+{
+  dir_pos->sname.cln = 0;
+  dir_pos->sname.ofs = 0;
+  dir_pos->lname.cln = FAT_FILE_SHORT_NAME;
+  dir_pos->lname.ofs = FAT_FILE_SHORT_NAME;
+}
+
 static inline uint32_t
 fat_cluster_num_to_sector_num(
     rtems_filesystem_mount_table_entry_t *mt_entry,
Index: cpukit/libfs/src/dosfs/fat_file.c
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libfs/src/dosfs/fat_file.c,v
retrieving revision 1.13
diff -p -u -u -r1.13 fat_file.c
--- cpukit/libfs/src/dosfs/fat_file.c	9 Mar 2009 14:11:23 -0000	1.13
+++ cpukit/libfs/src/dosfs/fat_file.c	23 Apr 2009 07:54:40 -0000
@@ -33,20 +33,20 @@
 #include "fat_file.h"
 
 static inline void
-_hash_insert(Chain_Control *hash, uint32_t   key1, uint32_t   key2,
+_hash_insert(rtems_chain_control *hash, uint32_t   key1, uint32_t   key2,
              fat_file_fd_t *el);
 
 static inline void
-_hash_delete(Chain_Control *hash, uint32_t   key1, uint32_t   key2,
+_hash_delete(rtems_chain_control *hash, uint32_t   key1, uint32_t   key2,
              fat_file_fd_t *el);
 
 static inline int
 _hash_search(
     rtems_filesystem_mount_table_entry_t  *mt_entry,
-    Chain_Control                         *hash,
+    rtems_chain_control                   *hash,
     uint32_t                               key1,
     uint32_t                               key2,
-    fat_file_fd_t			   **ret
+    fat_file_fd_t			                   **ret
 );
 
 static off_t
@@ -75,8 +75,7 @@ fat_file_lseek(
  *
  * PARAMETERS:
  *     mt_entry - mount table entry
- *     cln      - cluster num of the node
- *     ofs      - offset of the node
+ *     pos      - cluster and offset of the node
  *     fat_fd   - placeholder for returned fat-file descriptor
  *
  * RETURNS:
@@ -86,8 +85,7 @@ fat_file_lseek(
 int
 fat_file_open(
     rtems_filesystem_mount_table_entry_t  *mt_entry,
-    uint32_t                               cln,
-    uint32_t                               ofs,
+    fat_dir_pos_t                         *dir_pos,
     fat_file_fd_t                        **fat_fd
     )
 {
@@ -97,7 +95,7 @@ fat_file_open(
     uint32_t       key = 0;
 
     /* construct key */
-    key = fat_construct_key(mt_entry, cln, ofs);
+    key = fat_construct_key(mt_entry, &dir_pos->sname);
 
     /* access "valid" hash table */
     rc = _hash_search(mt_entry, fs_info->vhash, key, 0, &lfat_fd);
@@ -116,10 +114,14 @@ fat_file_open(
     if ( lfat_fd == NULL )
         rtems_set_errno_and_return_minus_one( ENOMEM );
 
+    memset(lfat_fd, 0, sizeof(fat_file_fd_t));
+    
     lfat_fd->links_num = 1;
     lfat_fd->flags &= ~FAT_FILE_REMOVED;
     lfat_fd->map.last_cln = FAT_UNDEFINED_VALUE;
 
+    lfat_fd->dir_pos = *dir_pos;
+
     if ( rc != RC_OK )
         lfat_fd->ino = key;
     else
@@ -138,7 +140,6 @@ fat_file_open(
     }
     _hash_insert(fs_info->vhash, key, lfat_fd->ino, lfat_fd);
 
-
     /*
      * other fields of fat-file descriptor will be initialized on upper
      * level
@@ -203,7 +204,7 @@ fat_file_close(
         return rc;
     }
 
-    key = fat_construct_key(mt_entry, fat_fd->info_cln, fat_fd->info_ofs);
+    key = fat_construct_key(mt_entry, &fat_fd->dir_pos.sname);
 
     if (fat_fd->flags & FAT_FILE_REMOVED)
     {
@@ -582,6 +583,8 @@ fat_file_extend(
         }
     }
 
+    fat_fd->fat_file_size = new_length;
+    
     return RC_OK;
 }
 
@@ -736,7 +739,7 @@ fat_file_mark_removed(
     fat_fs_info_t *fs_info = mt_entry->fs_info;
     uint32_t       key = 0;
 
-    key = fat_construct_key(mt_entry, fat_fd->info_cln, fat_fd->info_ofs);
+    key = fat_construct_key(mt_entry, &fat_fd->dir_pos.sname);
 
     _hash_delete(fs_info->vhash, key, fat_fd->ino, fat_fd);
 
@@ -869,10 +872,10 @@ fat_file_size(
  *     None
  */
 static inline void
-_hash_insert(Chain_Control *hash, uint32_t   key1, uint32_t   key2,
+_hash_insert(rtems_chain_control *hash, uint32_t   key1, uint32_t   key2,
              fat_file_fd_t *el)
 {
-    _Chain_Append((hash) + ((key1) % FAT_HASH_MODULE), &(el)->link);
+    rtems_chain_append((hash) + ((key1) % FAT_HASH_MODULE), &(el)->link);
 }
 
 
@@ -889,10 +892,10 @@ _hash_insert(Chain_Control *hash, uint32
  *     None
  */
 static inline void
-_hash_delete(Chain_Control *hash, uint32_t   key1, uint32_t   key2,
+_hash_delete(rtems_chain_control *hash, uint32_t   key1, uint32_t   key2,
              fat_file_fd_t *el)
 {
-    _Chain_Extract(&(el)->link);
+    rtems_chain_extract(&(el)->link);
 }
 
 /* _hash_search --
@@ -912,20 +915,19 @@ _hash_delete(Chain_Control *hash, uint32
 static inline int
 _hash_search(
     rtems_filesystem_mount_table_entry_t  *mt_entry,
-    Chain_Control                         *hash,
+    rtems_chain_control                   *hash,
     uint32_t                               key1,
     uint32_t                               key2,
     fat_file_fd_t                          **ret
     )
 {
-    uint32_t   mod = (key1) % FAT_HASH_MODULE;
-    Chain_Node *the_node = ((Chain_Control *)((hash) + mod))->first;
+    uint32_t          mod = (key1) % FAT_HASH_MODULE;
+    rtems_chain_node *the_node = ((rtems_chain_control *)((hash) + mod))->first;
 
-    for ( ; !_Chain_Is_tail((hash) + mod, the_node) ; )
+    for ( ; !rtems_chain_is_tail((hash) + mod, the_node) ; )
     {
         fat_file_fd_t *ffd = (fat_file_fd_t *)the_node;
-        uint32_t   ck =
-                fat_construct_key(mt_entry, ffd->info_cln, ffd->info_ofs);
+        uint32_t       ck =  fat_construct_key(mt_entry, &ffd->dir_pos.sname);
 
         if ( (key1) == ck)
         {
Index: cpukit/libfs/src/dosfs/fat_file.h
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libfs/src/dosfs/fat_file.h,v
retrieving revision 1.8
diff -p -u -u -r1.8 fat_file.h
--- cpukit/libfs/src/dosfs/fat_file.h	4 Feb 2009 12:45:21 -0000	1.8
+++ cpukit/libfs/src/dosfs/fat_file.h	23 Apr 2009 07:54:40 -0000
@@ -20,6 +20,8 @@
 
 #include <time.h>
 
+#include "fat.h"
+
 #ifdef __cplusplus
 extern "C" {
 #endif
@@ -57,30 +59,27 @@ typedef struct fat_file_map_s
  */
 typedef struct fat_file_fd_s
 {
-    Chain_Node      link;          /*
-                                    * fat-file descriptors organized into hash;
-                                    * collision lists are handled via link
-                                    * field
-                                    */
-    uint32_t        links_num;     /*
-                                    * the number of fat_file_open call on
-                                    * this fat-file
-                                    */
-    uint32_t        ino;           /* inode, file serial number :)))) */
-    fat_file_type_t fat_file_type;
-    uint32_t        size_limit;
-    uint32_t        fat_file_size; /* length  */
-    uint32_t        info_cln;
-    uint32_t        cln;
-    uint16_t        info_ofs;
-    unsigned char   first_char;
-    uint8_t         flags;
-    fat_file_map_t  map;
-    time_t          mtime;
+    rtems_chain_node link;          /*
+                                     * fat-file descriptors organized into hash;
+                                     * collision lists are handled via link
+                                     * field
+                                     */
+    uint32_t         links_num;     /*
+                                     * the number of fat_file_open call on
+                                     * this fat-file
+                                     */
+    uint32_t         ino;           /* inode, file serial number :)))) */
+    fat_file_type_t  fat_file_type;
+    uint32_t         size_limit;
+    uint32_t         fat_file_size; /* length  */
+    uint32_t         cln;
+    fat_dir_pos_t    dir_pos;
+    uint8_t          flags;
+    fat_file_map_t   map;
+    time_t           mtime;
 
 } fat_file_fd_t;
 
-
 #define FAT_FILE_REMOVED  0x01
 
 #define FAT_FILE_IS_REMOVED(p)\
@@ -101,8 +100,8 @@ typedef struct fat_file_fd_s
 #define FAT_ROOTDIR_CLUSTER_NUM 0x01
 
 #define FAT_FD_OF_ROOT_DIR(fat_fd)  \
-  ((fat_fd->info_cln == FAT_ROOTDIR_CLUSTER_NUM ) && \
-  (fat_fd->info_ofs == 0))
+  ((fat_fd->dir_pos.sname.cln == FAT_ROOTDIR_CLUSTER_NUM) && \
+  (fat_fd->dir_pos.sname.ofs == 0))
 
 #define FAT_EOF           0x00
 
@@ -122,19 +121,17 @@ typedef struct fat_file_fd_s
 static inline uint32_t
 fat_construct_key(
     rtems_filesystem_mount_table_entry_t *mt_entry,
-    uint32_t                              cl,
-    uint32_t                              ofs)
+    fat_pos_t                            *pos)
 {
-    return ( ((fat_cluster_num_to_sector512_num(mt_entry, cl) +
-              (ofs >> FAT_SECTOR512_BITS)) << 4)              +
-              ((ofs >> 5) & (FAT_DIRENTRIES_PER_SEC512 - 1)) );
+    return ( ((fat_cluster_num_to_sector512_num(mt_entry, pos->cln) +
+              (pos->ofs >> FAT_SECTOR512_BITS)) << 4)              +
+              ((pos->ofs >> 5) & (FAT_DIRENTRIES_PER_SEC512 - 1)) );
 }
 
 /* Prototypes for "fat-file" operations */
 int
 fat_file_open(rtems_filesystem_mount_table_entry_t  *mt_entry,
-              uint32_t                               cln,
-              uint32_t                               ofs,
+              fat_dir_pos_t                         *dir_pos,
               fat_file_fd_t                        **fat_fd);
 
 int
Index: cpukit/libfs/src/dosfs/msdos.h
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libfs/src/dosfs/msdos.h,v
retrieving revision 1.18
diff -p -u -u -r1.18 msdos.h
--- cpukit/libfs/src/dosfs/msdos.h	9 Mar 2009 14:11:23 -0000	1.18
+++ cpukit/libfs/src/dosfs/msdos.h	23 Apr 2009 07:54:40 -0000
@@ -84,8 +84,10 @@ typedef rtems_filesystem_node_types_t ms
 #define MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE    32 /* 32 bytes */
 
 #define MSDOS_DIR_NAME(x)                 (char     *)((x) + 0)
+#define MSDOS_DIR_ENTRY_TYPE(x)           (uint8_t  *)((x) + 0)
 #define MSDOS_DIR_ATTR(x)                 (uint8_t  *)((x) + 11)
 #define MSDOS_DIR_NT_RES(x)               (uint8_t  *)((x) + 12)
+#define MSDOS_DIR_LFN_CHECKSUM(x)         (uint8_t  *)((x) + 13)
 #define MSDOS_DIR_CRT_TIME_TENTH(x)       (uint8_t  *)((x) + 13)
 #define MSDOS_DIR_CRT_TIME(x)             (uint16_t *)((x) + 14)
 #define MSDOS_DIR_CRT_DATE(x)             (uint16_t *)((x) + 16)
@@ -121,6 +123,19 @@ typedef rtems_filesystem_node_types_t ms
 #define MSDOS_ATTR_VOLUME_ID    0x08
 #define MSDOS_ATTR_DIRECTORY    0x10
 #define MSDOS_ATTR_ARCHIVE      0x20
+#define MSDOS_ATTR_LFN          (MSDOS_ATTR_READ_ONLY | \
+                                 MSDOS_ATTR_HIDDEN | \
+                                 MSDOS_ATTR_SYSTEM | \
+                                 MSDOS_ATTR_VOLUME_ID)
+#define MSDOS_ATTR_LFN_MASK     (MSDOS_ATTR_READ_ONLY | \
+                                 MSDOS_ATTR_HIDDEN | \
+                                 MSDOS_ATTR_SYSTEM | \
+                                 MSDOS_ATTR_VOLUME_ID | \
+                                 MSDOS_ATTR_DIRECTORY | \
+                                 MSDOS_ATTR_ARCHIVE)
+
+#define MSDOS_LAST_LONG_ENTRY         0x40
+#define MSDOS_LAST_LONG_ENTRY_MASK    0x3F
 
 #define MSDOS_DT_2SECONDS_MASK        0x1F    /* seconds divided by 2 */
 #define MSDOS_DT_2SECONDS_SHIFT       0
@@ -144,22 +159,35 @@ typedef rtems_filesystem_node_types_t ms
 #define MSDOS_THIS_DIR_ENTRY_EMPTY             0xE5
 #define MSDOS_THIS_DIR_ENTRY_AND_REST_EMPTY    0x00
 
+/*
+ * Number of characters per directory entry for a long filename.
+ */
+#define MSDOS_LFN_LEN_PER_ENTRY (13)
 
 /*
  *  Macros for names parsing and formatting
  */
-#define msdos_is_valid_name_char(_ch)    (1)
 #define msdos_is_separator(_ch)          rtems_filesystem_is_separator(_ch)
 
 #define MSDOS_SHORT_BASE_LEN             8  /* 8 characters */
 #define MSDOS_SHORT_EXT_LEN              3  /* 3 characters */
 #define MSDOS_SHORT_NAME_LEN             (MSDOS_SHORT_BASE_LEN+\
                                           MSDOS_SHORT_EXT_LEN) /* 11 chars */
+#define MSDOS_NAME_MAX_LNF_LEN           (255)
 #define MSDOS_NAME_MAX                   MSDOS_SHORT_NAME_LEN
 #define MSDOS_NAME_MAX_WITH_DOT          (MSDOS_NAME_MAX + 1)
+#define MSDOS_NAME_MAX_LFN_WITH_DOT      (260)
+
 
-#define MSDOS_DOT_NAME     ".          " /* ".", padded to MSDOS_NAME chars */
-#define MSDOS_DOTDOT_NAME  "..         " /* "..", padded to MSDOS_NAME chars */
+extern const char const* MSDOS_DOT_NAME;    /* ".", padded to MSDOS_NAME chars */
+extern const char const* MSDOS_DOTDOT_NAME; /* ".", padded to MSDOS_NAME chars */
+
+typedef enum msdos_name_types_e
+{
+    MSDOS_NAME_INVALID = 0, /* Unknown name type. Has invalid characters. */
+    MSDOS_NAME_SHORT,       /* Name can be short. */
+    MSDOS_NAME_LONG         /* Name is long; cannot be short. */
+} msdos_name_type_t;
 
 typedef enum msdos_token_types_e
 {
@@ -258,9 +286,9 @@ ssize_t msdos_file_write(
   size_t         count            /* IN  */
 );
 
-off_t msdos_file_lseek(
+rtems_off64_t msdos_file_lseek(
   rtems_libio_t        *iop,              /* IN  */
-  off_t                 offset,           /* IN  */
+  rtems_off64_t         offset,           /* IN  */
   int                   whence            /* IN  */
 );
 
@@ -272,7 +300,7 @@ int msdos_file_stat(
 int
 msdos_file_ftruncate(
   rtems_libio_t *iop,               /* IN  */
-  off_t          length             /* IN  */
+  rtems_off64_t  length            /* IN  */
 );
 
 int msdos_file_sync(rtems_libio_t *iop);
@@ -285,6 +313,12 @@ int msdos_file_ioctl(
   void          *buffer           /* IN  */
 );
 
+int
+msdos_dir_chmod(
+  rtems_filesystem_location_info_t *pathloc, /* IN */
+  mode_t                            mode     /* IN */
+);
+
 int msdos_file_rmnod(rtems_filesystem_location_info_t *pathloc /* IN */);
 
 int msdos_file_link(
@@ -308,12 +342,18 @@ ssize_t msdos_dir_read(
   size_t         count             /* IN  */
 );
 
-off_t msdos_dir_lseek(
+rtems_off64_t msdos_dir_lseek(
   rtems_libio_t        *iop,              /* IN  */
-  off_t                 offset,           /* IN  */
+  rtems_off64_t         offset,           /* IN  */
   int                   whence            /* IN  */
 );
 
+int
+msdos_file_chmod(
+  rtems_filesystem_location_info_t *pathloc, /* IN */
+  mode_t                            mode     /* IN */
+);
+
 int msdos_dir_rmnod(rtems_filesystem_location_info_t *pathloc /* IN */);
 
 int msdos_dir_sync(rtems_libio_t *iop);
@@ -324,31 +364,39 @@ int msdos_dir_stat(
 );
 
 int msdos_creat_node(rtems_filesystem_location_info_t  *parent_loc,
-                 msdos_node_type_t                  type,
-                 char                              *name,
-                 mode_t                             mode,
-                 const fat_file_fd_t               *link_fd);
+                     msdos_node_type_t                  type,
+                     const char                        *name,
+                     int                                name_len,
+                     mode_t                             mode,
+                     const fat_file_fd_t               *link_fd);
 
 /* Misc prototypes */
-msdos_token_types_t msdos_get_token(const char *path,
-                                    char       *token,
-                                    int        *token_len);
+msdos_token_types_t msdos_get_token(const char  *path,
+                                    const char **token,
+                                    int         *token_len);
 
 int msdos_find_name(
   rtems_filesystem_location_info_t *parent_loc,
-  char                             *name
+  const char                       *name,
+  int                               name_len
 );
 
 int msdos_get_name_node(
   rtems_filesystem_location_info_t *parent_loc,
-  char                             *name,
-  fat_auxiliary_t                  *paux,
+  bool                              create_node,
+  const char                       *name,
+  int                               name_len,
+  msdos_name_type_t                 name_type,
+  fat_dir_pos_t                    *dir_pos,
   char                             *name_dir_entry
 );
 
 int msdos_dir_info_remove(rtems_filesystem_location_info_t *pathloc);
 
-int msdos_filename_unix2dos(char *un, int unlen, char *dn);
+msdos_name_type_t msdos_long_to_short(const char *lfn, int lfn_len,
+                                      char* sfn, int sfn_len);
+
+int msdos_filename_unix2dos(const char *un, int unlen, char *dn);
 
 void msdos_date_unix2dos(
   unsigned int tsp, unsigned short *ddp,
@@ -368,9 +416,8 @@ int msdos_set_file_size(
 
 int msdos_set_first_char4file_name(
   rtems_filesystem_mount_table_entry_t *mt_entry,
-  uint32_t    cl,
-  uint32_t    ofs,
-  unsigned char first_char
+  fat_dir_pos_t                        *dir_pos,
+  unsigned char                         first_char
 );
 
 int msdos_set_dir_wrt_time_and_date(
@@ -388,8 +435,11 @@ int msdos_dir_is_empty(
 int msdos_find_name_in_fat_file(
     rtems_filesystem_mount_table_entry_t *mt_entry,
     fat_file_fd_t                        *fat_fd,
-    char                                 *name,
-    fat_auxiliary_t                      *paux,
+    bool                                  create_node,
+    const char                           *name,
+    int                                   name_len,
+    msdos_name_type_t                     name_type,
+    fat_dir_pos_t                        *dir_pos,
     char                                 *name_dir_entry
 );
 
@@ -397,14 +447,14 @@ int msdos_find_node_by_cluster_num_in_fa
     rtems_filesystem_mount_table_entry_t *mt_entry,
     fat_file_fd_t                        *fat_fd,
     uint32_t                              cl4find,
-    fat_auxiliary_t                      *paux,
+    fat_dir_pos_t                        *dir_pos,
     char                                 *dir_entry
 );
 
 int msdos_get_dotdot_dir_info_cluster_num_and_offset(
     rtems_filesystem_mount_table_entry_t *mt_entry,
     uint32_t                              cln,
-    fat_auxiliary_t                      *paux,
+    fat_dir_pos_t                        *dir_pos,
     char                                 *dir_entry
 );
 
Index: cpukit/libfs/src/dosfs/msdos_conv.c
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libfs/src/dosfs/msdos_conv.c,v
retrieving revision 1.6
diff -p -u -u -r1.6 msdos_conv.c
--- cpukit/libfs/src/dosfs/msdos_conv.c	26 Oct 2004 09:48:53 -0000	1.6
+++ cpukit/libfs/src/dosfs/msdos_conv.c	23 Apr 2009 07:54:40 -0000
@@ -169,6 +169,39 @@ msdos_date_dos2unix(unsigned int dd, uns
 }
 
 static const uint8_t msdos_map[] = {
+    0,    0,    0,    0,    0,    0,    0,    0,    /* 00-07 */
+    0,    0,    0,    0,    0,    0,    0,    0,    /* 08-0f */
+    0,    0,    0,    0,    0,    0,    0,    0,    /* 10-17 */
+    0,    0,    0,    0,    0,    0,    0,    0,    /* 18-1f */
+    0,    '!',  0,    '#',  '$',  '%',  '&',  '\'', /* 20-27 */
+    '(',  ')',  0,    '+',  0,    '-',  0,    0,    /* 28-2f */
+    '0',  '1',  '2',  '3',  '4',  '5',  '6',  '7',  /* 30-37 */
+    '8',  '9',  0,    0,    0,    0,    0,    0,    /* 38-3f */
+    '@',  'A',  'B',  'C',  'D',  'E',  'F',  'G',  /* 40-47 */
+    'H',  'I',  'J',  'K',  'L',  'M',  'N',  'O',  /* 48-4f */
+    'P',  'Q',  'R',  'S',  'T',  'U',  'V',  'W',  /* 50-57 */
+    'X',  'Y',  'Z',  0,    0,    0,    '^',  '_',  /* 58-5f */
+    '`',  'A',  'B',  'C',  'D',  'E',  'F',  'G',  /* 60-67 */
+    'H',  'I',  'J',  'K',  'L',  'M',  'N',  'O',  /* 68-6f */
+    'P',  'Q',  'R',  'S',  'T',  'U',  'V',  'W',  /* 70-77 */
+    'X',  'Y',  'Z',  '{',  0,    '}',  '~',  0,    /* 78-7f */
+    0,    0,    0,    0,    0,    0,    0,    0,    /* 80-87 */
+    0,    0,    0,    0,    0,    0,    0,    0,    /* 88-8f */
+    0,    0,    0,    0,    0,    0,    0,    0,    /* 90-97 */
+    0,    0,    0,    0,    0,    0,    0,    0,    /* 98-9f */
+    0,    0xad, 0xbd, 0x9c, 0xcf, 0xbe, 0xdd, 0xf5, /* a0-a7 */
+    0xf9, 0xb8, 0xa6, 0xae, 0xaa, 0xf0, 0xa9, 0xee, /* a8-af */
+    0xf8, 0xf1, 0xfd, 0xfc, 0xef, 0xe6, 0xf4, 0xfa, /* b0-b7 */
+    0xf7, 0xfb, 0xa7, 0xaf, 0xac, 0xab, 0xf3, 0xa8, /* b8-bf */
+    0xb7, 0xb5, 0xb6, 0xc7, 0x8e, 0x8f, 0x92, 0x80, /* c0-c7 */
+    0xd4, 0x90, 0xd2, 0xd3, 0xde, 0xd6, 0xd7, 0xd8, /* c8-cf */
+    0xd1, 0xa5, 0xe3, 0xe0, 0xe2, 0xe5, 0x99, 0x9e, /* d0-d7 */
+    0x9d, 0xeb, 0xe9, 0xea, 0x9a, 0xed, 0xe8, 0xe1, /* d8-df */
+    0xb7, 0xb5, 0xb6, 0xc7, 0x8e, 0x8f, 0x92, 0x80, /* e0-e7 */
+    0xd4, 0x90, 0xd2, 0xd3, 0xde, 0xd6, 0xd7, 0xd8, /* e8-ef */
+    0xd1, 0xa5, 0xe3, 0xe0, 0xe2, 0xe5, 0x99, 0xf6, /* f0-f7 */
+    0x9d, 0xeb, 0xe9, 0xea, 0x9a, 0xed, 0xe8, 0x98, /* f8-ff */
+#if OLD_TABLE
 /* 00 */ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 /* 08 */ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 /* 10 */ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
@@ -201,13 +234,14 @@ static const uint8_t msdos_map[] = {
 /* E8 */ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 /* F0 */ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 /* F8 */ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+#endif
 };
 /*
  * Convert a unix filename to a DOS filename. Return -1 if wrong name is
  * supplied.
  */
 int
-msdos_filename_unix2dos(char *un, int unlen, char *dn)
+msdos_filename_unix2dos(const char *un, int unlen, char *dn)
 {
 	int i;
 	uint8_t c;
@@ -233,6 +267,14 @@ msdos_filename_unix2dos(char *un, int un
 		return 0;
 	}
 
+  /*
+   * Remove any dots from the start of a file name.
+   */
+	while (unlen && (*un == '.')) {
+		un++;
+		unlen--;
+	}
+  
 	/*
 	 * Copy the unix filename into the dos filename string upto the end
 	 * of string, a '.', or 8 characters. Whichever happens first stops
@@ -240,8 +282,9 @@ msdos_filename_unix2dos(char *un, int un
 	 * upper case.
 	 */
 	for (i = 0; i <= 7 && unlen && (c = *un) && c != '.'; i++) {
-		if ((dn[i] = msdos_map[c]) == 0)
-                        return -1;
+    if (msdos_map[c] == 0)
+      break;
+		dn[i] = msdos_map[c];
 		un++;
 		unlen--;
 	}
@@ -264,8 +307,9 @@ msdos_filename_unix2dos(char *un, int un
 	 * Filenames in this form are probably inaccessable under dos.
 	 */
 	for (i = 8; i <= 10 && unlen && (c = *un); i++) {
-		if ((dn[i] = msdos_map[c]) == 0)
-		        return -1;
+    if (msdos_map[c] == 0)
+      break;
+    dn[i] = msdos_map[c];
 		un++;
 		unlen--;
 	}
